#include "disconnect_cleanup_client.h"
#include "handle_work_completion.h"
#include "rdma_common_client.h"

#include <assert.h>

int disconnect(struct client_common *client) {
    struct rdma_cm_event *event;
    int err;


    // Disconnect from the server
    rdma_disconnect(client->common.cm_id);

    // Handle CM events
    err = rdma_get_cm_event(client->common.cm_channel, &event);
    if (err)
        return err;
    assert(event->event == RDMA_CM_EVENT_DISCONNECTED);
    rdma_ack_cm_event(event);

    return 0;
}

int cleanup(struct client_common *client) {
    free_common(&client->common);

    return 0;
}



