#include "disconnect_cleanup_server.h"
#include "handle_work_completion.h"
#include "rdma_common_server.h"

#include <assert.h>


int disconnect(struct server_common *server) {
    struct rdma_cm_event *event;
    int err;

    // Wait for the client to notify us that it has completed

    // TODO check for errors


    // Handle CM events
    err = rdma_get_cm_event(server->common.cm_channel, &event);
    if (err)
        return err;
    assert(event->event == RDMA_CM_EVENT_DISCONNECTED);
    rdma_ack_cm_event(event);

    // Disconnect from the client
    rdma_disconnect(server->common.cm_id);

    return 0;
}

int cleanup(struct server_common *server) {
	int err;

    // Deregister the memory region
    err = ibv_dereg_mr(server->client_metadata_mr);
    assert(err == 0);

    free_common(&server->common);

    return 0;
}



