#include "common.h"
#include "rdma_common_client.h"
#include "handle_work_completion.h"
#include "read.h"

#include <assert.h>

void read_to_from_fence(struct common *common, local_var local, remote_var remote, bool fence) {
    struct ibv_sge sge;
    struct ibv_send_wr send_wr = {};
    struct ibv_send_wr *bad_send_wr;

    /* Fill up SGE     */
    set_local_var(common, &sge, local);

	/* Link to the send work request */
    send_wr.wr_id 					= 0;
    send_wr.opcode 					= IBV_WR_RDMA_READ;
    
    /* Set IBV_SEND_SIGNALED flag will cause an ibv event recv at sender when data transmit from memory to NIC */
    send_wr.send_flags 				= IBV_SEND_SIGNALED;
    if (fence)
        send_wr.send_flags |= IBV_SEND_FENCE;
    send_wr.sg_list 				= &sge;
    send_wr.num_sge 				= 1;

    set_remote_var(common, &send_wr, remote);

	/* Post it */
    if (ibv_post_send(common->cm_id->qp, &send_wr, &bad_send_wr))
        return;
}

void read_to_from(struct common *common, local_var local, remote_var remote) {
    read_to_from_fence(common, local, remote, false);
}
